#ifndef DUNE_PERFTOOL_MULADD_WORKAROUNDS_HH
#define DUNE_PERFTOOL_MULADD_WORKAROUNDS_HH

/* We are currently having some issues with FMA nodes not being
 * eliminated correctly upon code generation. We "solve" the problem
 * for now with overloads of the mul_add function for scalars.
 */

#include<dune/perftool/common/opcounter.hh>


inline double mul_add(double op1, double& op2, double op3)
{
	return op1 * op2 + op3;
}


inline float mul_add(float op1, float& op2, float op3)
{
	return op1 * op2 + op3;
}


#ifdef ENABLE_COUNTER

oc::OpCounter<double> mul_add(oc::OpCounter<double> op1, oc::OpCounter<double>& op2, oc::OpCounter<double> op3)
{
	return op1 * op2 + op3;
}

oc::OpCounter<float> mul_add(oc::OpCounter<float> op1, oc::OpCounter<float>& op2, oc::OpCounter<float> op3)
{
	return op1 * op2 + op3;
}

#endif

#endif
